darcs

Issue 1819 pull --dont-allow-conflicts doesn't work w external-merge

Title pull --dont-allow-conflicts doesn't work w external-merge
Priority bug Status has-patch
Milestone Resolved in
Superseder Nosy List darcs-devel, dmitry.kurochkin, fx, ganesh, kowey
Assigned To
Topics Conflicts

Created on 2010-04-18.11:26:56 by fx, last changed 2022-04-12.14:49:45 by bf.

Messages
msg10751 (view) Author: fx Date: 2010-04-18.11:26:56
Pulling with --dont-allow-conflicts when there is a conflict doesn't
fail as it should, but asks me to resolve it.  (--skip-conflicts does
work.)  I'll send a test.
msg10753 (view) Author: kowey Date: 2010-04-18.11:33:23
Uh-oh!  Would you be able to help us out by sending a regression testing
script for this bug?  It's really easy.

See http://wiki.darcs.net/Development/RegressionTests

Thanks! 

PS. this is my first or second attempt at using a semi-canned response
(I think it was Trent who gave me the idea)
msg10756 (view) Author: fx Date: 2010-04-18.12:02:39
Eric Kow <bugs@darcs.net> writes:

> Eric Kow <kowey@darcs.net> added the comment:
>
> Uh-oh!  Would you be able to help us out by sending a regression testing
> script for this bug?  It's really easy.

I already did, once I got the issue number (patch212).
msg10825 (view) Author: kowey Date: 2010-04-26.17:05:23
Thanks for the test case (rah! that really helps us move things along).
Adding Ganesh because I think he may be particularly interested.

Assuming the test case is accepted, we need investigation to work out
what the underlying problem is.
msg10827 (view) Author: ganesh Date: 2010-04-26.17:14:26
On Mon, 26 Apr 2010, Eric Kow wrote:

>
> Eric Kow <kowey@darcs.net> added the comment:
>
> Thanks for the test case (rah! that really helps us move things along).
> Adding Ganesh because I think he may be particularly interested.
>
> Assuming the test case is accepted, we need investigation to work out
> what the underlying problem is.

>From memory, --external-merge trumps --dont-allow-conflicts (the two 
don't really make sense together). I haven't checked the code to confirm 
that though.

Ganesh
msg10842 (view) Author: fx Date: 2010-04-26.21:29:01
Ganesh Sittampalam <ganesh@earth.li> writes:

> From memory, --external-merge trumps --dont-allow-conflicts (the two 
> don't really make sense together). I haven't checked the code to confirm 
> that though.

OK.  That's not documented.  I think it's the wrong way round,
particularly as you don't seem to be able to do something like
--no-external-merge to turn off what you have in ~/.darcs/defaults.
msg10843 (view) Author: ganesh Date: 2010-04-26.22:43:05
On Mon, 26 Apr 2010, Dave Love wrote:

> Ganesh Sittampalam <ganesh@earth.li> writes:
>
>> From memory, --external-merge trumps --dont-allow-conflicts (the two
>> don't really make sense together). I haven't checked the code to confirm
>> that though.
>
> OK.  That's not documented.  I think it's the wrong way round,
> particularly as you don't seem to be able to do something like
> --no-external-merge to turn off what you have in ~/.darcs/defaults.

I agree that the interactions are confusing and inconsistent and that you 
need a way to be able to disable options from the defaults etc. This was 
discussed during the --skip-conflicts thread late last year, but noone has 
done much about it since. (Though I thought someone did at least 
add negative versions of all existing options, but I could be 
misremembering.)
msg10856 (view) Author: kowey Date: 2010-04-27.16:06:32
On Mon, Apr 26, 2010 at 23:42:24 +0100, Ganesh Sittampalam wrote:
> I agree that the interactions are confusing and inconsistent and that you 
> need a way to be able to disable options from the defaults etc. This was  
> discussed during the --skip-conflicts thread late last year, but noone 
> has done much about it since. (Though I thought someone did at least add 
> negative versions of all existing options, but I could be  
> misremembering.)

Florent added a lot of --no-foo flags.  It seems like we need a
--no-external-merge flag along that vein of work.

Related bugs:
- http://bugs.darcs.net/issue1457
- http://bugs.darcs.net/issue1550

Aside from implementing --no-external-merge, do we need to do anything
else in particular?

-- 
Eric Kow <http://www.nltg.brighton.ac.uk/home/Eric.Kow>
PGP Key ID: 08AC04F9
msg10873 (view) Author: ganesh Date: 2010-04-27.20:28:50
On Tue, 27 Apr 2010, Eric Kow wrote:

> On Mon, Apr 26, 2010 at 23:42:24 +0100, Ganesh Sittampalam wrote:
>> I agree that the interactions are confusing and inconsistent and that you
>> need a way to be able to disable options from the defaults etc. This was
>> discussed during the --skip-conflicts thread late last year, but noone
>> has done much about it since. (Though I thought someone did at least add
>> negative versions of all existing options, but I could be
>> misremembering.)
>
> Florent added a lot of --no-foo flags.  It seems like we need a
> --no-external-merge flag along that vein of work.
>
> Related bugs:
> - http://bugs.darcs.net/issue1457
> - http://bugs.darcs.net/issue1550
>
> Aside from implementing --no-external-merge, do we need to do anything
> else in particular?

I'm not sure if last option currently wins (with defaults coming before 
the command-line). If it doesn't, it should.

There's also been some discussion about cleaning up the conflict-allowing 
options, in this thread:

http://lists.osuosl.org/pipermail/darcs-users/2009-October/021664.html

I don't really know the right answer so am not inclined to do anything in 
a rush, but it should be kept in mind when looking at this area.
msg10949 (view) Author: kowey Date: 2010-05-05.15:09:38
OK, I gather this is just about implementation then (plus tweaking the
test comments to reflect the real nature of the bug).  Thanks!
History
Date User Action Args
2010-04-18 11:26:56fxcreate
2010-04-18 11:33:24koweysetnosy: + kowey
messages: + msg10753
2010-04-18 12:02:40fxsetmessages: + msg10756
2010-04-26 17:05:25koweysetpriority: bug
status: unknown -> needs-reproduction
topic: + Conflicts
messages: + msg10825
nosy: + ganesh
2010-04-26 17:14:27ganeshsetmessages: + msg10827
2010-04-26 21:29:02fxsetmessages: + msg10842
2010-04-26 22:43:06ganeshsetmessages: + msg10843
2010-04-27 16:06:33koweysetmessages: + msg10856
2010-04-27 20:28:51ganeshsetmessages: + msg10873
2010-05-05 15:09:39koweysetstatus: needs-reproduction -> needs-implementation
messages: + msg10949
2010-05-05 15:09:50koweysettitle: pull --dont-allow-conflicts doesn't work -> pull --dont-allow-conflicts doesn't work w external-merge
2017-07-30 23:57:08ghsetstatus: needs-implementation -> given-up
2022-04-12 14:49:45bfsetstatus: given-up -> has-patch